var mozless_enabled;
var mozless_debug;
var mozless_focusMode;
var mozless_emacskeys;
var mozless_swapuandi;

var mozless_sb;

var mozless_focusedFrameIndex;

var mozless_isFirefox = (mozless_getAppName() == "Firefox");

function mozless_init_settings()
{
  var prefs = Components.classes["@mozilla.org/preferences-service;1"]
    .getService(Components.interfaces.nsIPrefService)
    .getBranch("extensions.mozless.");

  mozless_enabled = mozless_getBoolPref(prefs, "enabled", true);
  mozless_debug = mozless_getBoolPref(prefs, "debug", false);
  mozless_focusMode = mozless_getBoolPref(prefs, "focusmode", false);
  mozless_emacskeys = mozless_getBoolPref(prefs, "emacskeys", false);
  mozless_swapuandi = mozless_getBoolPref(prefs, "swapuandi", false);

  if (mozless_enabled && mozless_getAppName() != "Firefox") {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
      .getService(Components.interfaces.nsIPrefBranch);

    if (prefs.getBoolPref("accessibility.typeaheadfind.autostart") == true) {
      prefs.setBoolPref("accessibility.typeaheadfind.autostart", false);
      if (mozless_getAppName() != "Firefox")
	alert("mozless: "
	      + mozless_sb.GetStringFromName("autostart_is_suppressed")
	      + " (accessibility.typeaheadfind.autostart = false)");
    }
    if (prefs.getBoolPref("accessibility.typeaheadfind.linksonly") == true) {
      prefs.setBoolPref("accessibility.typeaheadfind.linksonly", false);
      alert("mozless: "
	    + mozless_sb.GetStringFromName("linksonly_is_suppressed")
	    + " (accessibility.typeaheadfind.linksonly = false)");
    }
  }
}

function mozless_init(e) {
  var sbs = Components.classes["@mozilla.org/intl/stringbundle;1"].
    getService(Components.interfaces.nsIStringBundleService);
  mozless_sb = sbs.createBundle("chrome://mozless/locale/messages.properties");

  mozless_init_settings(); // XXX

  if (window._content.frames.length > 0) {
    mozless_focusedFrameIndex = 0;
    window._content.frames[mozless_focusedFrameIndex].focus();
  } else {
    mozless_focusedFrameIndex = null;
  }
}

//////////////////////////////////////////////////////////////////////
//
// key event handling
//

window.addEventListener("keypress", mozless_onkeypress, false);

function mozless_onkeypress(e)
{
  if (!mozless_enabled) return;

  if (!mozless_finding() && mozless_is_normal_target(e)) {
    if (mozless_do_mapping(e)) e.preventDefault();
    return;
  }

  if(!mozless_finding() && mozless_detect_form(e)) {
    if (mozless_do_mapping_in_form(e)) e.preventDefault();
    return;
  }
}

function mozless_is_normal_target(e)
{
  return !mozless_detect_form(e) && !mozless_detect_designmode(e);
}

function mozless_finding()
{
  if (!mozless_isFirefox) return false;
  else return !document.getElementById("FindToolbar").hidden;
}

function mozless_detect_form(e)
{
  return /^(input|textarea|textbox|select)$/i
    .test(Components.lookupMethod(e.originalTarget, 'localName')
	  .call(e.originalTarget));
}

function mozless_detect_designmode(e)
{
  var doc = Components.lookupMethod
    (e.originalTarget, 'ownerDocument').call(e.originalTarget);
  return Components.lookupMethod(doc, 'designMode').call(doc) == 'on';
}

function mozless_do_mapping(e)
{

  // char code

  if (!e.altKey && !e.ctrlKey && !e.metaKey)
    switch (String.fromCharCode(e.charCode)) {

    case 'o':
      mozless_function_focus_mode();
      return true;
    case 'k':
      mozless_function_previous();
      return true;
    case 'j':
      mozless_function_next();
      return true;
    case 'h':
      mozless_function_back();
      return true;
    case 'l':
      mozless_function_forward();
      return true;
    case 'u':
      if (!mozless_swapuandi) mozless_function_half_page_up(e);
      else mozless_function_half_page_down(e);
      return true;
    case 'i':
      if (!mozless_swapuandi) mozless_function_half_page_down(e);
      else mozless_function_half_page_up(e);
      return true;
    case 'b':
      mozless_function_page_up();
      return true;
    case 'f':
      mozless_function_page_down();
      return true;
      //case ' ':
      //mozless_function_page_down();
      //return true;
    case 'd':
      mozless_function_half_page_down(e);
      return true;
    case 'g':
      mozless_function_top();
      return true;
    case 'v':
      mozless_function_open_bookmarks();
      return true;
    case 'n':
      findNext();
      return true;
    case 'q':
      BrowserCloseTabOrWindow();
      return true;
    case 't':
      mozless_function_new_tab();
      return true;
    case 'm':
      mozless_function_previous_tab();
      return true;
    case ',':
      mozless_function_next_tab();
      return true;
    case '.':
      mozless_function_open_tab();
      return true;
    case 'w':
      mozless_function_previous_frame();
      return true;
    case 'e':
      mozless_function_next_frame();
      return true;

    case 'G':
      mozless_function_bottom();
      return true;
    case 'B':
      BrowserBack();
      return true;
    case 'F':
      BrowserForward();
      return true;
    case 'R':
      BrowserReload();
      return true;
    case 'S':
      BrowserStop();
      return true;
    case 'H':
      BrowserHome();
      return true;
    case 'U':
      openLocation();
      return true;
    case 'N':
      findPrevious();
      return true;
    case 'Q':
      BrowserCloseWindow();
      return true;

      /*
    case 'a': {
      var focus = document.commandDispatcher.focusedElement;
      if(!focus) {
	alert("hello");
	return true;
      }
      alert("x:"+focus.offsetLeft+" y:"+focus.offsetTop+"\n"
	    +"ow:"+focus.offsetWidth+" oh:"+focus.offsetHeight+"\n");
      return true;
    }
      */

    }

  // key code

  if (!e.altKey && !e.ctrlKey && !e.metaKey && !e.shiftKey)
    switch (e.keyCode) {

    case e.DOM_VK_UP:
      mozless_function_previous();
      return true;
    case e.DOM_VK_DOWN:
      mozless_function_next();
      return true;
    case e.DOM_VK_LEFT:
      mozless_function_back();
      return true;
    case e.DOM_VK_RIGHT:
      mozless_function_forward();
      return true;
    case e.DOM_VK_HOME:
      mozless_function_top();
      return true;
    case e.DOM_VK_END:
      mozless_function_bottom();
      return true;
    case e.DOM_VK_PAGE_UP:
      mozless_function_page_up();
      return true;
    case e.DOM_VK_PAGE_DOWN:
      mozless_function_page_down();
      return true;

    }

  // control mode

  if (!e.altKey && e.ctrlKey && !e.metaKey && !e.shiftKey) {
    switch (String.fromCharCode(e.charCode)) {

    case 'p':
      if (mozless_emacskeys) {
	mozless_function_previous();
	return true;
      } else {
	return false;
      }
    case 'n':
      if (mozless_emacskeys) {
	mozless_function_next();
	return true;
      } else {
	return false;
      }
    case 'b':
      if (mozless_emacskeys) {
	mozless_function_back();
	return true;
      } else {
	return false;
      }
    case 'f':
      if (mozless_emacskeys) {
	mozless_function_forward();
	return true;
      } else {
	return false;
      }
    case 'j':
      if (mozless_emacskeys) {
	mozless_function_next();
	return true;
      } else {
	return false;
      }
    case 'v':
      if (mozless_emacskeys) {
	mozless_function_page_down();
	return true;
      } else {
	return false;
      }
    case ';':
      mozless_function_jump_field();
      return true;

    }

  }

  if (!e.altKey && e.ctrlKey && !e.metaKey && e.shiftKey) {
    switch (String.fromCharCode(e.charCode)) {

    case ';':
      mozless_function_jump_field_reverse();
      return true;
    }

  }

  return false;
}

function mozless_do_mapping_in_form(e)
{
  if (!e.altKey && e.ctrlKey && !e.metaKey && !e.shiftKey) {
    switch (String.fromCharCode(e.charCode)) {

    case ';':
      mozless_function_jump_field();
      return true;
    }

  }

  if (!e.altKey && e.ctrlKey && !e.metaKey && e.shiftKey) {
    switch (String.fromCharCode(e.charCode)) {

    case ';':
      mozless_function_jump_field_reverse();
      return true;
    }

  }
}

//////////////////////////////////////////////////////////////////////
//
// functions
//

function mozless_function_previous()
{
  if (mozless_focusMode) mozless_focusUp();
  else goDoCommand('cmd_scrollLineUp');
}

function mozless_function_next()
{
  if (mozless_focusMode) mozless_focusDown();
  else goDoCommand('cmd_scrollLineDown');
}

function mozless_function_back()
{
  if (mozless_focusMode) mozless_focusLeft();
  else goDoCommand('cmd_scrollLeft');
}

function mozless_followLink()
{
  var focus = document.commandDispatcher.focusedElement;
  if (!focus) return;
  window._content.open(focus.href, "_self");
}

function mozless_function_forward()
{
  if (mozless_focusMode) mozless_focusRight();
  else goDoCommand('cmd_scrollRight');
}

function mozless_function_page_up()
{
  goDoCommand('cmd_scrollPageUp');
  if (mozless_focusMode) mozless_focusBottom();
}

function mozless_function_page_down()
{
  goDoCommand('cmd_scrollPageDown');
  if (mozless_focusMode) mozless_focusTop();
}

function mozless_function_half_page_up(e)
{
  var w = Components.lookupMethod(e.originalTarget, 'ownerDocument')
    .call(e.originalTarget).defaultView;
  w.scrollBy(0, -w.innerHeight/2);

  if (mozless_focusMode) mozless_focusBottom();
}

function mozless_function_half_page_down(e)
{
  var focus = document.commandDispatcher.focusedElement;
  if (focus == null) {
    var w = Components.lookupMethod(e.originalTarget, 'ownerDocument')
      .call(e.originalTarget).defaultView;
    w.scrollBy(0, w.innerHeight/2);
  } else {
    var w = focus.ownerDocument.defaultView;
    w.scrollBy(0, w.innerHeight/2);
  }

  if (mozless_focusMode) mozless_focusTop();
}

function mozless_function_top()
{
  goDoCommand('cmd_scrollTop');
  if (mozless_focusMode) mozless_focusTop();
}

function mozless_function_bottom()
{
  goDoCommand('cmd_scrollBottom');
  if (mozless_focusMode) mozless_focusBottom();
}

function mozless_function_open_bookmarks()
{
  var dirService = Components
    .classes['@mozilla.org/file/directory_service;1']
    .getService(Components.interfaces.nsIProperties);

  const NS_APP_USER_PROFILE_50_DIR = "ProfD";
  profileDir = dirService.get
    (NS_APP_USER_PROFILE_50_DIR, Components.interfaces.nsIFile);

  var bookmarksURL = "file://" + profileDir.path + "/bookmarks.html";
  window._content.open(bookmarksURL, "_self");
}

function mozless_function_new_tab()
{
  var homePage = gHomeButton.getHomePage();
  delayedOpenTab(homePage);
}

// NOTE: delta must be small :)
function mozless_tabRelativeSelect(delta)
{
  var oldTab = gBrowser.selectedTab;
  var newTab = null;
  var length = gBrowser.tabContainer.childNodes.length;
  var index;
  for (index=0; index<length; index++) {
    if (gBrowser.tabContainer.childNodes[index] == oldTab) {
      var new_index = index + delta;
      if (new_index < 0) new_index += length;
      else if (new_index >= length) new_index -= length;
      newTab = gBrowser.tabContainer.childNodes[new_index];
      break;
    }
  }
  if (newTab && newTab != oldTab)
    gBrowser.selectedTab = newTab;
}

function mozless_function_previous_tab()
{
  mozless_tabRelativeSelect(-1);
}

function mozless_function_next_tab()
{
  mozless_tabRelativeSelect(+1);
}

function mozless_function_open_tab()
{
  var focus = document.commandDispatcher.focusedElement;
  if (!focus) return;
  gBrowser.selectedTab = gBrowser.addTab(focus.href);
}

function mozless_function_previous_frame()
{
  if (window._content.frames.length > 0) {
    if (mozless_focusedFrameIndex == null) {
      mozless_focusedFrameIndex = 0;
    } else {
      mozless_focusedFrameIndex--;
      if (mozless_focusedFrameIndex < 0)
	mozless_focusedFrameIndex = window._content.frames.length - 1;
    }
    window._content.frames[mozless_focusedFrameIndex].focus();
  }
}

function mozless_function_next_frame()
{
  if (window._content.frames.length > 0) {
    if (mozless_focusedFrameIndex == null) {
      mozless_focusedFrameIndex = 0;
    } else {
      mozless_focusedFrameIndex++;
      if (mozless_focusedFrameIndex >= window._content.frames.length)
	mozless_focusedFrameIndex = 0;
    }
    window._content.frames[mozless_focusedFrameIndex].focus();
  }
}

//////////////////////////////////////////////////////////////////////
/*
  firstfield (http://firstfield.mozdev.org/)
  Copyright (c) 2003 Vadim Kolontsov <vk@tvcom.ru>
*/

function mozless_get_nth_field(doc, n, m)
{
  var elements = doc.forms[n].elements;

  var count = 0;
  for (var j=0; j < elements.length; j++) {
    if (elements[j].type == "text"
	|| elements[j].type == "textarea"
	|| elements[j].type == "password") {
      count++;
      if (count == m + 1) {
	return elements[j];
      }
    }
  }
  return null;
}

function mozless_count_fields(doc, n)
{
  var elements = doc.forms[n].elements;

  var count = 0;
  for (var j=0; j < elements.length; j++) {
    if (elements[j].type == "text"
	|| elements[j].type == "textarea"
	|| elements[j].type == "password") {
      count++;
    }
  }
  return count;
}

function mozless_function_jump_field() {
  var doc = window.content.document;
  if (!doc) return;

  if (doc.form_id == undefined) doc.form_id = 0;
  if (doc.field_id == undefined) doc.field_id = -1;

  for (var i=0; i<2; i++) {
    while (doc.form_id < doc.forms.length) {
      var field = mozless_get_nth_field(doc, doc.form_id, doc.field_id + 1);
      if (field) {
	field.focus();
	field.select();
	doc.field_id++;
	return;
      }

      doc.form_id++;
      doc.field_id = -1;
    }
    doc.form_id = 0;
  }
}

function mozless_function_jump_field_reverse() {
  var doc = window.content.document;
  if (!doc) return;

  if (doc.form_id == undefined) doc.form_id = doc.forms.length - 1;
  if (doc.field_id == undefined)
    doc.field_id = mozless_count_fields(doc, doc.form_id);

  for (var i=0; i<2; i++) {
    while (doc.form_id >= 0) {
      var field = mozless_get_nth_field(doc, doc.form_id, doc.field_id - 1);
      if (field) {
	field.focus();
	field.select();
	doc.field_id--;
	return;
      }

      doc.form_id--;
      if (doc.form_id >= 0)
	doc.field_id = mozless_count_fields(doc, doc.form_id);
    }
    doc.form_id = doc.forms.length - 1;
    doc.field_id = mozless_count_fields(doc, doc.form_id);
  }
}

//////////////////////////////////////////////////////////////////////

function mozless_getX(a)
{
  if (a.mozless_x != undefined) return a.mozless_x;
  var aa = a;

  var x = 0;
  for ( ; a; a = a.offsetParent)
    x += a.offsetLeft;

  aa.mozless_x = x;
  return x;
}

function mozless_getY(a)
{
  if (a.mozless_y != undefined) return a.mozless_y;
  var aa = a;

  var y = 0;
  for ( ; a; a = a.offsetParent)
    y += a.offsetTop;

  aa.mozless_y = y;
  return y;
}

function mozless_focusLeftMost()
{
  var w = window._content;
  var links = w.document.links;
  var link = null;
  for (var i=0; i<links.length; i++) {
    if (mozless_getX(links[i]) >= w.pageXOffset
	&& mozless_getX(links[i]) + links[i].offsetWidth
	< w.pageXOffset + w.innerWidth
	&& mozless_getY(links[i]) >= w.pageYOffset
	&& mozless_getY(links[i]) + links[i].offsetHeight
	< w.pageYOffset + w.innerHeight) {
      if (!link) {
	link = links[i];
      } else {
	if (links[i].offsetLeft < link.offsetLeft)
	  link = links[i];
      }
    }
  }
  if (link) {
    link.focus();
    link.select();
  }
}

function mozless_focusRightMost()
{
  var w = window._content;
  var links = w.document.links;
  var link = null;
  for (var i=0; i<links.length; i++) {
    if (mozless_getX(links[i]) >= w.pageXOffset
	&& mozless_getX(links[i]) + links[i].offsetWidth
	< w.pageXOffset + w.innerWidth
	&& mozless_getY(links[i]) >= w.pageYOffset
	&& mozless_getY(links[i]) + links[i].offsetHeight
	< w.pageYOffset + w.innerHeight) {
      if (!link) {
	link = links[i];
      } else {
	if (links[i].offsetLeft > link.offsetLeft)
	  link = links[i];
      }
    }
  }
  if (link) {
    link.focus();
    link.select();
  }
}

function mozless_focusUpMost()
{
  var w = window._content;
  var links = w.document.links;
  var link = null;
  for (var i=0; i<links.length; i++) {
    if (mozless_getX(links[i]) >= w.pageXOffset
	&& mozless_getX(links[i]) + links[i].offsetWidth
	< w.pageXOffset + w.innerWidth
	&& mozless_getY(links[i]) >= w.pageYOffset
	&& mozless_getY(links[i]) + links[i].offsetHeight
	< w.pageYOffset + w.innerHeight) {
      if (!link) {
	link = links[i];
      } else {
	if (links[i].offsetTop < link.offsetTop)
	  link = links[i];
      }
    }
  }
  if (link) {
    link.focus();
    link.select();
  }
}

function mozless_focusDownMost()
{
  var w = window._content;
  var links = w.document.links;
  var link = null;
  for (var i=0; i<links.length; i++) {
    if (mozless_getX(links[i]) >= w.pageXOffset
	&& mozless_getX(links[i]) + links[i].offsetWidth
	< w.pageXOffset + w.innerWidth
	&& mozless_getY(links[i]) >= w.pageYOffset
	&& mozless_getY(links[i]) + links[i].offsetHeight
	< w.pageYOffset + w.innerHeight) {
      if (!link) {
	link = links[i];
      } else {
	if (links[i].offsetTop > link.offsetTop)
	  link = links[i];
      }
    }
  }
  if (link) {
    link.focus();
    link.select();
  }
}

/*
  CrossFire
  http://tkm.s31.xrea.com/xul/crossfire_en.shtml
*/

function mozless_up_distance(a, b)
{
  var u;
  var v = mozless_getY(b) + b.offsetHeight - mozless_getY(a);
 
  if (mozless_getX(b) + b.offsetWidth < mozless_getX(a))
    var u = mozless_getX(b) + b.offsetWidth - mozless_getX(a);
  else if (mozless_getX(b) > mozless_getX(a) + a.offsetWidth)
    var u = mozless_getX(b) - (mozless_getX(a) + a.offsetWidth);
  else
    var u = 0;

  return u*u + v*v;
}

function mozless_down_distance(a, b)
{
  var u;
  var v = mozless_getY(b) - (mozless_getY(a) + a.offsetHeight);
  
  if (mozless_getX(b) + b.offsetWidth < mozless_getX(a))
    var u = mozless_getX(b) + b.offsetWidth - mozless_getX(a);
  else if (mozless_getX(b) > mozless_getX(a) + a.offsetWidth)
    var u = mozless_getX(b) - (mozless_getX(a) + a.offsetWidth);
  else
    var u = 0;

  return u*u + v*v;
}

function mozless_left_distance(a, b)
{
  var u = mozless_getX(b) + b.offsetWidth - mozless_getX(a);
  var v;

  if (mozless_getY(b) + b.offsetHeight < mozless_getY(a))
    var v = mozless_getY(b) + b.offsetHeight - mozless_getY(a);
  else if (mozless_getY(b) > mozless_getY(a) + a.offsetHeight)
    var v = mozless_getY(b) - (mozless_getY(a) + a.offsetHeight);
  else
    var v = 0;

  return u*u + v*v;
}

function mozless_right_distance(a, b)
{
  var u = mozless_getX(b) - (mozless_getX(a) + a.offsetWidth);
  var v;

  if (mozless_getY(b) + b.offsetHeight < mozless_getY(a))
    var v = mozless_getY(b) + b.offsetHeight - mozless_getY(a);
  else if (mozless_getY(b) > mozless_getY(a) + a.offsetHeight)
    var v = mozless_getY(b) - (mozless_getY(a) + a.offsetHeight);
  else
    var v = 0;

  return u*u + v*v;
}

function mozless_focusUp()
{
  var focus = document.commandDispatcher.focusedElement;
  if(!focus) {
    mozless_focusDownMost();
    return;
  }

  if (focus.mozless_up != undefined) {
    focus.mozless_up.focus();
    focus.mozless_up.select();
    return;
  }

  var w = window._content;
  var links = w.document.links;
  var link = null;
  var x = mozless_getX(focus);
  var y = mozless_getY(focus);
  var distance = null;
  for (var i=0; i<links.length; i++) {
    if (mozless_getY(links[i]) + links[i].offsetHeight <= y) {
      if (link == null) {
	link = links[i];
	distance = mozless_up_distance(focus, link);
      } else {
	if (distance > mozless_up_distance(focus, links[i])) {
	  link = links[i];
	  distance = mozless_up_distance(focus, link);
	}
      }
    }
  }
  if (link) {
    link.focus();
    link.select();

    // cache
    focus.mozless_up = link;
  }
}

function mozless_focusDown()
{
  var focus = document.commandDispatcher.focusedElement;
  if(!focus) {
    mozless_focusUpMost();
    return;
  }

  if (focus.mozless_down != undefined) {
    focus.mozless_down.focus();
    focus.mozless_down.select();
    return;
  }

  var w = window._content;
  var links = w.document.links;
  var link = null;
  var x = mozless_getX(focus);
  var y = mozless_getY(focus);
  var distance = null;
  for (var i=0; i<links.length; i++) {
    if (mozless_getY(links[i]) >= y + focus.offsetHeight) {
      if (link == null) {
	link = links[i];
	distance = mozless_down_distance(focus, link);
      } else {
	if (distance > mozless_down_distance(focus, links[i])) {
	  link = links[i];
	  distance = mozless_down_distance(focus, link);
	}
      }
    }
  }
  if (link) {
    link.focus();
    link.select();

    // cache
    focus.mozless_down = link;
  }
}

function mozless_focusLeft()
{
  var focus = document.commandDispatcher.focusedElement;
  if(!focus) {
    mozless_focusRightMost();
    return;
  }

  if (focus.mozless_left != undefined) {
    focus.mozless_left.focus();
    focus.mozless_left.select();
    return;
  }

  var w = window._content;
  var links = w.document.links;
  var link = null;
  var x = mozless_getX(focus);
  var y = mozless_getY(focus);
  var distance = null;
  for (var i=0; i<links.length; i++) {
    if (mozless_getX(links[i]) + links[i].offsetWidth <= x) {
      if (link == null) {
	link = links[i];
	distance = mozless_left_distance(focus, link);
      } else {
	if (distance > mozless_left_distance(focus, links[i])) {
	  link = links[i];
	  distance = mozless_left_distance(focus, link);
	}
      }
    }
  }
  if (link) {
    link.focus();
    link.select();

    // cache
    focus.mozless_left = link;
  }
}

function mozless_focusRight()
{
  var focus = document.commandDispatcher.focusedElement;
  if(!focus) {
    mozless_focusLeftMost();
    return;
  }

  if (focus.mozless_right != undefined) {
    focus.mozless_right.focus();
    focus.mozless_right.select();
    return;
  }

  var w = window._content;
  var links = w.document.links;
  var link = null;
  var x = mozless_getX(focus);
  var y = mozless_getY(focus);
  var distance = null;
  for (var i=0; i<links.length; i++) {
    if (mozless_getX(links[i]) >= x + focus.offsetWidth) {
      if (link == null) {
	link = links[i];
	distance = mozless_right_distance(focus, link);
      } else {
	if (distance > mozless_right_distance(focus, links[i])) {
	  link = links[i];
	  distance = mozless_right_distance(focus, link);
	}
      }
    }
  }
  if (link) {
    link.focus();
    link.select();

    // cache
    focus.mozless_right = link;
  }
}

function mozless_function_focus_mode()
{
  mozless_focusMode = !mozless_focusMode;
  if (!mozless_focusMode) return;

  var focus = document.commandDispatcher.focusedElement;
  if(!focus) {
    mozless_focusUpMost();
    return;
  }

  var w = window._content;
  if (mozless_getY(focus) < w.pageYOffset) {
    mozless_focusUpMost();
    return;
  }
  if (mozless_getY(focus)
      >= w.pageYOffset + w.innerHeight) {
    mozless_focusDownMost();
    return;
  }
  if (mozless_getX(focus) < w.pageXOffset) {
    mozless_focusLeftMost();
    return;
  }
  if (mozless_getX(focus)
      >= w.pageXOffset + w.innerWidth) {
    mozless_focusRightMost();
    return;
  }
}

//////////////////////////////////////////////////////////////////////

window.addEventListener("load", mozless_init, true);

function mozless_getBoolPref(prefs, name, d)
{
  if (prefs.prefHasUserValue(name))
    return prefs.getBoolPref(name);
  else
    return d;
}

function mozless_getIntPref(prefs, name, d)
{
  if (prefs.prefHasUserValue(name))
    return prefs.getIntPref(name);
  else
    return d;
}

function mozless_getCharPref(prefs, name, d)
{
  if (prefs.prefHasUserValue(name))
    return prefs.getCharPref(name);
  else
    return d;
}

MozlessPrefsObserver.prototype =
  {
    observe:
    function(subject, topic, data) {
      mozless_init_settings();
    }
  }

var mozless_prefs_observer = new MozlessPrefsObserver();

function MozlessPrefsObserver()
{
  try {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
      .getService(Components.interfaces.nsIPrefService)
      .getBranch(null);
    var pbi = prefs.QueryInterface
      (Components.interfaces.nsIPrefBranchInternal);
    pbi.addObserver("extensions.mozless", this, false);
  } catch (e) {
    alert(e);
  }
}

function mozless_getAppName()
{
  var name = null;

  try {
    var info = Components.classes["@mozilla.org/xre/app-info;1"]
      .getService(Components.interfaces.nsIXULAppInfo);
    name = info.name;
  } catch (e) { }

  return name;
}

// setting menu for Mozilla Suite

function mozless_settings()
{
  var dialog = window.openDialog
    ("chrome://mozless/content/mozlessPrefDialog.xul",
     null, "modal, centerscreen");
}
